#include <stdlib.h>
#include <stdio.h>
#include <time.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <errno.h>
#include <dirent.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/Xatom.h>
#include <X11/Xos.h>
#include <Imlib2.h>
#include "types.h"
#include "funcs.h"

int countHabaks(int argc, char *argv[], char habaks_index[]) {
int i,j=0;
for (i=1;i<argc;i++) {
if (argv[i][0]=='-') {
	/* Wykryto opcję, ale czy to Habak? */
	switch (argv[i][1]) {
	case IMAGE_HABAK:
		habaks_index[j]=i;
		j++;
		break;
	case FONT_HABAK:
		habaks_index[j]=i;
		j++;
		break;
	case INTERNAL_HABAK:
		habaks_index[j]=i;
		j++;
		break;
	}
}}
return j;
}

int parseHabak(int argc, char *argv[], unsigned char habaks_index[], int habak_number, int habaks_count, habak_t *habak){

int first_argc;
int last_argc;
short int count;
char fn1[512];
char *fp=NULL, *fn=NULL;
int i;
struct stat file_info;
double xco,yco;

first_argc=habaks_index[habak_number];
if (habak_number==habaks_count-1) {
	last_argc=argc;
} else {
last_argc=habaks_index[habak_number+1];
}

count=last_argc-first_argc;

if (!count) {
	/* Error - empty habak */
	fprintf(stderr, "Empty habak!\n");
	return 0;
}

switch (argv[first_argc][1]) {

	case IMAGE_HABAK:
		habak->type=IMAGE_HABAK;
		habak->file=argv[first_argc+1];
		strcpy(fn1,habak->file);
		
		if (stat(fn1, &file_info)==-1) {
			/* no such file? */
			return 0;
		} else {
			if (S_ISDIR(file_info.st_mode)) {
				randomly_select(fn1);
			}
		}
		if (!(habak->image=imlib_load_image_immediately(fn1))) {
		/* File load error */
			return 0;
		} else {
		imlib_context_set_image(habak->image);
		habak->width=habak->orig_width=imlib_image_get_width();
		habak->height=habak->orig_height=imlib_image_get_height();
		}
		break;
		
	case FONT_HABAK:
		habak->type=FONT_HABAK;
		strcpy(fn1,argv[first_argc+1]);
		if ((strstr(fn1,".ttf/")||strstr(fn1,".TTF/"))==0) {
			    strcat(fn1,"/30");
		}
		fp=rindex(fn1,'/');
		fp[0]='\0';
		fn=rindex(fn1,'/');
		fn[0]='\0';
		fn++;
		fp[0]='/';
		imlib_add_path_to_font_path(fn1);
		if (!(habak->font=imlib_load_font(fn))) {
			fprintf(stderr, "Font open failed.\n");
			return 0;
		}
		imlib_context_set_font(habak->font);
		break;
	case INTERNAL_HABAK:
		habak->type=INTERNAL_HABAK;
		habak->data=argv[first_argc+1];
		
		/* default values for interlace */
		habak->red=habak->green=habak->blue=0;
		habak->alpha=70;
		

		break;
}
for (i=first_argc+2;i<last_argc;i++) {
if (argv[i][0]!='-') {
	/* there's something rotten in the air */
	fprintf(stderr, "No option where options expected! %s\n",argv[i]);
	return 0;
} else {
	switch (argv[i][1]) {
	case MOD_CENTER:
		habak->x = (scr->width-habak->orig_width)/2;
		habak->y = (scr->height-habak->orig_height)/2;
		break;
	case MOD_SCALE:
		xco=((double)scr->width/(double)habak->orig_width);
		yco=((double)scr->height/(double)habak->orig_height);
		if (xco > yco) {xco=yco;}
		habak->width=habak->orig_width*xco;
		habak->height=habak->orig_height*yco;
		habak->x = (scr->width-habak->width)/2;
		habak->y = (scr->height-habak->height)/2;
		break;
	case MOD_TEXT:
		habak->data=argv[++i];
		imlib_get_text_advance(habak->data,&habak->width,&habak->height);
		habak->orig_width=habak->width;
		habak->orig_height=habak->height;
		break;
	case MOD_PAINT:
		habak->red=atoi(strsep(&argv[i+1],","));
		habak->green=atoi(strsep(&argv[i+1],","));
		habak->blue=atoi(strsep(&argv[i+1],","));
		habak->alpha=atoi(argv[i+1]);
		i++;
		break;
	case MOD_POSITION:
		if (argv[i+1][0]=='-') {habak->invx=1;} else {habak->invx=0;}
		habak->x=atoi(strsep(&(argv[i+1]),","));
		habak->y=atoi(argv[i+1]);
		if (argv[i+1][0]=='-') {habak->invy=1;} else {habak->invy=0;}
		if (habak->invx) {habak->x+=scr->width-habak->width;}
		if (habak->invy) {habak->y+=scr->height-habak->height;}
		if (habak->type==FONT_HABAK) {
//		if (habak->invx) {habak->x-=habak->width;}
//		if (habak->invy) {habak->y-=habak->height;}
		}
		i++;
		break;
	default: /* unknown option! */
		return 0;
}
}

}

	return 1;
}

habak_t habaks_array[256];
int habaks_count,j,i;
unsigned char habaks_index[256];
Imlib_Image workspace;

int main(int argc, char *argv[]) {
srand(time(NULL)+time(NULL)*1000);

initXconnection();

if ((habaks_count=countHabaks(argc,argv,habaks_index))) {
for (j=0;j<habaks_count;j++) {
if (parseHabak(argc,argv,habaks_index,j,habaks_count,&habaks_array[j])==0) {
	fprintf(stderr, "Error parsing Habak number %i!!\nAborted.\n",j);
};
/*
printf("Type: %i\nFile: %s\nX: %i\nY: %i\nWidth: %i,%i\nHeight: %i,%i\nR: %i\nG: \
%i\nB: %i\nA: %i\nData:	%s\n",\
habaks_array[j].type,
habaks_array[j].file,
habaks_array[j].x,
habaks_array[j].y,
habaks_array[j].width,
habaks_array[j].orig_width,
habaks_array[j].height,
habaks_array[j].orig_height,
habaks_array[j].red,
habaks_array[j].green,
habaks_array[j].blue,
habaks_array[j].alpha,
habaks_array[j].data);
*/
}

/* OK, I guess everything is fine now. So fire up the Imlib machine... */
workspace=imlib_create_image(scr->width,scr->height);
imlib_context_set_image(workspace);
imlib_context_set_anti_alias(1);
imlib_context_set_dither(1);
imlib_context_set_blend(1);

/* Should be down hill from here. I like this part, makes for a nice,
 * clean finish. Just the way I like them :) */

for (j=0;j<habaks_count;j++) {
switch (habaks_array[j].type) {	
	case FONT_HABAK:
	imlib_context_set_color(habaks_array[j].red,habaks_array[j].green,habaks_array[j].blue,habaks_array[j].alpha);
	imlib_context_set_font(habaks_array[j].font);
//	imlib_context_set_direction(IMLIB_TEXT_TO_ANGLE);
//	imlib_context_set_angle(0.09);
	imlib_text_draw(habaks_array[j].x,habaks_array[j].y,habaks_array[j].data);
	break;
	
	case INTERNAL_HABAK:
//		imlib_context_set_operation(IMLIB_OP_RESHADE);
		if (strncmp(habaks_array[j].data,INTERNAL_HABAK_INTERLACE,3)==0) {
		habaks_array[j].image=imlib_create_image(scr->width,scr->height);
		habaks_array[j].width=habaks_array[j].orig_width=scr->width;
		habaks_array[j].height=habaks_array[j].orig_height=scr->height;
		imlib_context_set_image(habaks_array[j].image);
		imlib_image_set_has_alpha(1);
		imlib_context_set_color(habaks_array[j].red,habaks_array[j].green,habaks_array[j].blue,habaks_array[j].alpha);
		for (i=0;i<scr->height;i+=2) {
			imlib_image_draw_line(0,i,habaks_array[j].width,i,0);
		}
		imlib_context_set_image(workspace);
		imlib_blend_image_onto_image(habaks_array[j].image, 0, 0,0,habaks_array[j].orig_width,habaks_array[j].orig_height,habaks_array[j].x,habaks_array[j].y,habaks_array[j].width,habaks_array[j].height);
		break;
		}
		if (strncmp(habaks_array[j].data,INTERNAL_HABAK_INTERLACE_REVERSED,3)==0) {
		habaks_array[j].image=imlib_create_image(scr->width,scr->height);
		habaks_array[j].width=habaks_array[j].orig_width=scr->width;
		habaks_array[j].height=habaks_array[j].orig_height=scr->height;
		imlib_context_set_image(habaks_array[j].image);
		imlib_image_set_has_alpha(1);
		imlib_context_set_color(habaks_array[j].red,habaks_array[j].green,habaks_array[j].blue,habaks_array[j].alpha);
		for (i=1;i<scr->height;i+=2) {imlib_image_draw_line(0,i,habaks_array[j].width,i,0);}
		imlib_context_set_image(workspace);
		imlib_blend_image_onto_image(habaks_array[j].image, 0, 0,0,habaks_array[j].orig_width,habaks_array[j].orig_height,habaks_array[j].x,habaks_array[j].y,habaks_array[j].width,habaks_array[j].height);
		break;
		}
	break;
	case IMAGE_HABAK:
	imlib_blend_image_onto_image(habaks_array[j].image, 0, 0,0,habaks_array[j].orig_width,habaks_array[j].orig_height,habaks_array[j].x,habaks_array[j].y,habaks_array[j].width,habaks_array[j].height);
	break;
}}

dumpToScreen();
set_pixmap_property(p);

}



return 0;
}

